
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class TeamsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const teams = await db.teams.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        slug: data.slug
        ||
        null
            ,
            
        team_status: data.team_status
        ||
        null
            ,
            
        always_on_room_enabled: data.always_on_room_enabled
        ||
        false
        
            ,
            
        always_on_state_retention_days: data.always_on_state_retention_days
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await teams.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await teams.setDepartment( data.department || null, {
            transaction,
        });
        

        

        

        return teams;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const teamsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                slug: item.slug
            ||
            null
            ,
            
                team_status: item.team_status
            ||
            null
            ,
            
                always_on_room_enabled: item.always_on_room_enabled
            ||
            false
        
            ,
            
                always_on_state_retention_days: item.always_on_state_retention_days
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const teams = await db.teams.bulkCreate(teamsData, { transaction });

        // For each item created, replace relation files
        

        return teams;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const teams = await db.teams.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.slug !== undefined) updatePayload.slug = data.slug;
        
        
        if (data.team_status !== undefined) updatePayload.team_status = data.team_status;
        
        
        if (data.always_on_room_enabled !== undefined) updatePayload.always_on_room_enabled = data.always_on_room_enabled;
        
        
        if (data.always_on_state_retention_days !== undefined) updatePayload.always_on_state_retention_days = data.always_on_state_retention_days;
        
        
        updatePayload.updatedById = currentUser.id;

        await teams.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await teams.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.department !== undefined) {
            await teams.setDepartment(
              
              data.department,
              
              { transaction }
            );
        }
        

        
        

        

        return teams;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const teams = await db.teams.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of teams) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of teams) {
                await record.destroy({transaction});
            }
        });


        return teams;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const teams = await db.teams.findByPk(id, options);

        await teams.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await teams.destroy({
            transaction
        });

        return teams;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const teams = await db.teams.findOne(
            { where },
            { transaction },
        );

        if (!teams) {
            return teams;
        }

        const output = teams.get({plain: true});

        
        
        
        
        
        
        
        
        output.memberships_team = await teams.getMemberships_team({
            transaction
        });
        
        
        
        
        
        
        output.conference_templates_team = await teams.getConference_templates_team({
            transaction
        });
        
        
        output.rooms_team = await teams.getRooms_team({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.app_installations_team = await teams.getApp_installations_team({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await teams.getOrganization({
            transaction
        });
        
        
        output.department = await teams.getDepartment({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.departments,
        as: 'department',
        
        where: filter.department ? {
          [Op.or]: [
            { id: { [Op.in]: filter.department.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.department.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'teams',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.slug) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'teams',
                        'slug',
                        filter.slug,
                    ),
                };
            }
            

            
            

            
            if (filter.always_on_state_retention_daysRange) {
                const [start, end] = filter.always_on_state_retention_daysRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    always_on_state_retention_days: {
                    ...where.always_on_state_retention_days,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    always_on_state_retention_days: {
                    ...where.always_on_state_retention_days,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.team_status) {
                where = {
                    ...where,
                team_status: filter.team_status,
            };
            }
            
            if (filter.always_on_room_enabled) {
                where = {
                    ...where,
                always_on_room_enabled: filter.always_on_room_enabled,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.teams.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'teams',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.teams.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

